routes/web.php
<?php

use App\Http\Controllers\back\NoticiaController as BackNoticiaController;
use App\Http\Controllers\front\NoticiaController as FrontNoticiaController;

use App\Http\Controllers\NoticiaController;
use App\Http\Controllers\ProfileController;
use Illuminate\Support\Facades\Route;

// esto lo pueden ver todos los usuarios

// pagina de inicio para el frontend
// Quiero listar todas las noticias con solo algunos campos
// y que cuando pinche en una noticia me muestre la noticia completa
// en el menu quiero que salga Panel Login Registrar

Route::controller(FrontNoticiaController::class)->group(function () {
    // muestra todas las noticias
    Route::get('/', 'index')->name('home');
    // mostrar una sola noticia en el frontEnd
    Route::get('/front/noticias/{noticia}', 'show')->name('front.noticias.show');
    Route::post('/front/noticias/buscar', 'buscar')->name('front.noticias.buscar');
});


// Los usuarios autenticados pueden ver esto
Route::middleware('auth')->group(function () {
    // pagina de inicio para el backend
    // quiero ver informacion del usuario
    // si pulso sobre el icono del menu me lleva al front
    // y un menu Gestion Noticias | Crear Noticia | Noticias del usuario | Dropdown de cerrar sesion (perfil|cerrar sesion)
    Route::get('/back/index', function () {
        return view('back.index');
    })->name('back.index');

    // para la gestion del perfil de usuario
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');

    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');

    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');


    // para mostrar las noticias del usuario logueado
    Route::controller(BackNoticiaController::class)->group(function () {
        Route::get('/back/noticias/listado', 'listado')->name('back.noticias.listado');
    });

    // para la gestion de las noticias
    Route::resource('back/noticias', BackNoticiaController::class)->names('back.noticias');
});



require __DIR__ . '/auth.php';

app/Models/Noticia.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Noticia extends Model
{
    use HasFactory;

    protected $table = 'noticias';

    protected $fillable = [
        'titulo',
        'contenido',
        'foto',
        'user_id'
    ];

    /**
     * Relacion con el modelo User
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/back/NoticiaController.php
<?php

namespace App\Http\Controllers\back;

use App\Http\Controllers\Controller;
use App\Models\Noticia;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;
use PHPUnit\Framework\TestStatus\Notice;

class NoticiaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        // Auth -> Facades de Laravel
        // Auth::user(); // Devuelve el usuario autenticado
        // Auth::check(); // Devuelve true si hay un usuario autenticado
        // Auth::guest(); // Devuelve true si no hay un usuario autenticado
        // Auth::user()->user_id; // Devuelve el id del usuario
        // Auth::id();
        // Auth::user()->name; // Devuelve el nombre del usuario

        // auth()->check(); // Devuelve true si hay un usuario autenticado
        // auth()->user()->user_id; // Devuelve el id del usuario
        // auth()->user()->name; // Devuelve el nombre del usuario

        // obtengo todas las noticias de todos los usuarios
        //$noticias = Noticia::all();
        // paginacion de contenido
        $noticias = Noticia::paginate(5);
        // renderizo la vista con todas las noticias
        // en la vista de backend 
        // en cada noticia tengo que colocar los botones de CRUD
        return view('back.noticias.index', compact('noticias'));
    }


    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('back.noticias.create', [
            'noticia' => new Noticia()
        ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $foto = $request->file('foto');

        $fichero = $foto->store('fotos', 'public');
        $noticia = new Noticia();
        $noticia->fill($request->all());
        $noticia->foto = $fichero;
        $noticia->user_id = Auth::id();
        $noticia->save();

        return redirect()
            ->route('back.noticias.show', $noticia);
    }

    /**
     * Display the specified resource.
     */
    public function show(Noticia $noticia)
    {
        return view('back.noticias.show', compact('noticia'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Noticia $noticia)
    {
        return view('back.noticias.edit', compact('noticia'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Noticia $noticia)
    {
        //
        if ($request->hasFile('foto')) {
            $foto = $request->file('foto');
            $fichero = $foto->store('fotos', 'public');
            $noticia->fill($request->all());
            $noticia->foto = $fichero;
        } else {
            $noticia->fill($request->all());
        }

        $noticia->user_id = Auth::id();
        $noticia->save();

        return redirect()
            ->route('back.noticias.show', $noticia);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Noticia $noticia)
    {
        Storage::disk('public')->delete($noticia->foto);

        $noticia->delete();

        return redirect()
            ->route('back.noticias.index');
    }
    public function listado()
    {
        // leer el id del usuario logueado
        $usuario = Auth::id();

        // obtener las noticias de ese usuario
        $noticias = Noticia::where('user_id', $usuario)->paginate(5);

        return view('back.noticias.index', compact('noticias'));
    }
}

app/Http/Controllers/front/NoticiaController.php
<?php

namespace App\Http\Controllers\front;

use App\Http\Controllers\Controller;
use App\Models\Noticia;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use PHPUnit\Framework\TestStatus\Notice;

class NoticiaController extends Controller
{

    /**
     * Debe mostrar todas las noticias
     * en frontEnd
     * No deben aparecer los botones de edicion
     * Solamente un boton para mostrar lo noticia completa
     */
    public function index()
    {
        // obtengo todas las noticias
        $noticias = Noticia::paginate(5);

        // renderizo la vista con todas las noticias
        // en la vista de frontEnd
        return view('front.index', compact('noticias'));
    }


    /**
     * Mostrar toda la noticia en el frontEnd
     */
    public function show(Noticia $noticia)
    {
        return view('front.noticias.show', compact('noticia'));
    }

    public function buscar(Request $request)
    {
        $noticias = Noticia::where('titulo', 'like', '%' . $request->busqueda . '%')
            ->orWhere('contenido', 'like', '%' . $request->busqueda . '%')
            ->paginate(5);

        return view('front.index', compact('noticias'));
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

/**
 * Este componente es el layout para las vistas
 * del BackEnd
 */
class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

resources/views/back/noticias/_form.blade.php
        <div>
            <label>Titulo</label>
            <input type="text" name="titulo" value="{{ old('titulo', $noticia->titulo) }}">
            @error('titulo')
                <div>{{ $message }}</div>
            @enderror
        </div>
        <div>
            <label>Contenido</label>
            <input type="text" name="contenido" value="{{ old('contenido', $noticia->contenido) }}">
            @error('contenido')
                <div>{{ $message }}</div>
            @enderror
        </div>
        <div>
            <label>Foto</label>
            @if ($noticia->foto)
                <img src="{{ asset('storage/' . $noticia->foto) }}" id="preview">
            @else
                <img id="preview">
            @endif
            <input type="file" name="foto" value="{{ $noticia->foto }}" id="fichero">
            @error('foto')
                <div>{{ $message }}</div>
            @enderror
        </div>
        <div>
            <button type="submit"
                class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded">Enviar</button>
        </div>

resources/views/back/noticias/create.blade.php
<x-app-layout>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <form action="{{ route('back.noticias.store') }}" method="POST" enctype="multipart/form-data"
                class="bg-white dark:bg-gray-800 overflow-hidden shadow-sm sm:rounded-lg">
                @csrf
                @include('back.noticias._form')

            </form>
        </div>

    </div>
</x-app-layout>

resources/views/back/noticias/edit.blade.php
<x-app-layout>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <form action="{{ route('back.noticias.update', $noticia) }}" method="POST" enctype="multipart/form-data"
                class="bg-white dark:bg-gray-800 overflow-hidden shadow-sm sm:rounded-lg">
                @csrf
                @method('PUT')
                @include('back.noticias._form')

            </form>
        </div>

    </div>
</x-app-layout>

resources/views/back/noticias/index.blade.php
<x-app-layout>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            @foreach ($noticias as $noticia)
                <div class="bg-white mt-4 dark:bg-gray-800 overflow-hidden shadow-sm sm:rounded-lg">
                    @if ($noticia->foto)
                        <div class="p-6 text-gray-900 dark:text-gray-100 text-center m-4"
                            style="background-repeat: no-repeat; background-size:contain; background-position: center; width:400px; height:400px; background-image: url('{{ asset('storage/' . $noticia->foto) }}')">

                        </div>
                    @endif
                    <div class="p-6 text-gray-900 dark:text-gray-100">
                        {{ $noticia->titulo }}
                    </div>
                    <div class="p-6 text-gray-900 dark:text-gray-100">
                        {{ $noticia->contenido }}
                    </div>

                    <div class="m-6 text-sm text-left">
                        <div class="text-blue-400 capitalize">Creador: {{ $noticia->user->name }}</div>
                        <div class="text-blue-400">Actualizacion: {{ $noticia->updated_at }}</div>
                    </div>
                    <div class="p-6 text-gray-900 dark:text-gray-100 text-right">
                        <a href="{{ route('back.noticias.show', $noticia) }}" class="text-blue-500"> Mostrar</a>
                        <a href="{{ route('back.noticias.edit', $noticia) }}" class="text-blue-500"> Editar</a>
                        <form action="{{ route('back.noticias.destroy', $noticia) }}" method="POST" id="eliminar"
                            class="inline">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="text-red-500"> Eliminar</button>
                        </form>
                    </div>

                </div>
            @endforeach
            <div class="mt-4">
                {{ $noticias->links() }}
            </div>
        </div>

    </div>
</x-app-layout>

resources/views/back/noticias/show.blade.php
<x-app-layout>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">

            <h2 class="text-xl font-semibold text-black dark:text-white">
                {{ $noticia->titulo }}
            </h2>
            <div class="mt-4 flex size-60 shrink-0 items-center justify-center rounded-full bg-[#FF2D20]/10 ">
                <img src="{{ asset('storage/' . $noticia->foto) }}" alt="">
            </div>
            <p class="mt-4 text-sm/relaxed">
                {{ $noticia->contenido }}
            </p>
            <div class="mt-6 text-sm text-right">
                Creador: <div class="text-blue-400 capitalize">
                    {{ $noticia->user->name }}
                </div>

                Fecha creacion: <div class="text-blue-400">
                    {{ $noticia->updated_at }}
                </div>
            </div>
            <div class="mt-6 text-left">
                <a href="{{ route('back.noticias.edit', $noticia) }}"
                    class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded">
                    Editar</a>
                <form action="{{ route('back.noticias.destroy', $noticia) }}" method="POST" id="eliminar"
                    class="inline">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="bg-red-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded">
                        Eliminar</button>
                </form>
            </div>
        </div>
    </div>
</x-app-layout>